'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Card = require('@material-ui/core/Card');

var _Card2 = _interopRequireDefault(_Card);

var _CssBaseline = require('@material-ui/core/CssBaseline');

var _CssBaseline2 = _interopRequireDefault(_CssBaseline);

var _colors = require('@material-ui/core/colors');

var _styles = require('@material-ui/core/styles');

require('./subsonic/api/RadioMaker');

var _LoginCredentials = require('./subsonic/components/creds/LoginCredentials');

var _LoginCredentials2 = _interopRequireDefault(_LoginCredentials);

var _ImportCredentials = require('./subsonic/components/creds/ImportCredentials');

var _ImportCredentials2 = _interopRequireDefault(_ImportCredentials);

var _AuthCodeClient = require('./subfire/components/creds/AuthCodeClient');

var _AuthCodeClient2 = _interopRequireDefault(_AuthCodeClient);

var _AuthCodeSource = require('./subfire/components/creds/AuthCodeSource');

var _AuthCodeSource2 = _interopRequireDefault(_AuthCodeSource);

var _CredentialsActions = require('./subsonic/actions/CredentialsActions');

var _CredentialsActions2 = _interopRequireDefault(_CredentialsActions);

var _CredentialsContainer = require('./subsonic/components/containers/CredentialsContainer');

var _CredentialsContainer2 = _interopRequireDefault(_CredentialsContainer);

var _RemotesActions = require('./subfire/actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

var _SubsonicContainer = require('./subsonic/components/containers/SubsonicContainer');

var _SubsonicContainer2 = _interopRequireDefault(_SubsonicContainer);

var _PlaylistsBrowser = require('./subsonic/components/browsers/PlaylistsBrowser');

var _PlaylistsBrowser2 = _interopRequireDefault(_PlaylistsBrowser);

var _AlbumQueryBrowser = require('./subsonic/components/browsers/AlbumQueryBrowser');

var _AlbumQueryBrowser2 = _interopRequireDefault(_AlbumQueryBrowser);

var _ServerSelect = require('./subsonic/components/browsers/ServerSelect');

var _ServerSelect2 = _interopRequireDefault(_ServerSelect);

var _ArtistsBrowser = require('./subsonic/components/browsers/ArtistsBrowser');

var _ArtistsBrowser2 = _interopRequireDefault(_ArtistsBrowser);

var _AlbumSongBrowser = require('./subsonic/components/browsers/AlbumSongBrowser');

var _AlbumSongBrowser2 = _interopRequireDefault(_AlbumSongBrowser);

var _PlaylistBrowser = require('./subsonic/components/browsers/PlaylistBrowser');

var _PlaylistBrowser2 = _interopRequireDefault(_PlaylistBrowser);

var _ArtistAlbumsBrowser = require('./subsonic/components/browsers/ArtistAlbumsBrowser');

var _ArtistAlbumsBrowser2 = _interopRequireDefault(_ArtistAlbumsBrowser);

var _DirectoryBrowser = require('./subsonic/components/browsers/DirectoryBrowser');

var _DirectoryBrowser2 = _interopRequireDefault(_DirectoryBrowser);

var _IndexBrowser = require('./subsonic/components/browsers/IndexBrowser');

var _IndexBrowser2 = _interopRequireDefault(_IndexBrowser);

var _TreeBrowser = require('./subsonic/components/browsers/TreeBrowser');

var _TreeBrowser2 = _interopRequireDefault(_TreeBrowser);

var _NowPlayingBrowser = require('./subsonic/components/browsers/NowPlayingBrowser');

var _NowPlayingBrowser2 = _interopRequireDefault(_NowPlayingBrowser);

var _BookmarksBrowser = require('./subsonic/components/browsers/BookmarksBrowser');

var _BookmarksBrowser2 = _interopRequireDefault(_BookmarksBrowser);

var _PodcastsBrowser = require('./subsonic/components/browsers/PodcastsBrowser');

var _PodcastsBrowser2 = _interopRequireDefault(_PodcastsBrowser);

var _VideoBrowser = require('./subsonic/components/browsers/VideoBrowser');

var _VideoBrowser2 = _interopRequireDefault(_VideoBrowser);

var _RadioBrowser = require('./subfire/components/browsers/RadioBrowser');

var _RadioBrowser2 = _interopRequireDefault(_RadioBrowser);

var _Muppet = require('./subfire/components/external/Muppet');

var _Muppet2 = _interopRequireDefault(_Muppet);

var _Search = require('./subsonic/components/search/Search');

var _Search2 = _interopRequireDefault(_Search);

var _Preferences = require('./subfire/components/Preferences');

var _Preferences2 = _interopRequireDefault(_Preferences);

var _LoadedSongsBrowser = require('./subsonic/components/browsers/LoadedSongsBrowser');

var _LoadedSongsBrowser2 = _interopRequireDefault(_LoadedSongsBrowser);

var _ColorContainer = require('./subfire/components/containers/ColorContainer');

var _ColorContainer2 = _interopRequireDefault(_ColorContainer);

var _ColorTheme = require('./subfire/components/containers/ColorTheme');

var _ColorTheme2 = _interopRequireDefault(_ColorTheme);

var _RemoteConfigScreen = require('./subfire/components/remotes/RemoteConfigScreen');

var _RemoteConfigScreen2 = _interopRequireDefault(_RemoteConfigScreen);

var _RemoteConfigInit = require('./subfire/components/remotes/RemoteConfigInit');

var _RemoteConfigInit2 = _interopRequireDefault(_RemoteConfigInit);

var _RemoteControl = require('./subfire/components/remotes/RemoteControl');

var _RemoteControl2 = _interopRequireDefault(_RemoteControl);

var _DemoPlayer = require('./components/DemoPlayer');

var _DemoPlayer2 = _interopRequireDefault(_DemoPlayer);

var _DemoMain = require('./components/DemoMain');

var _DemoMain2 = _interopRequireDefault(_DemoMain);

var _SubsonicLoader = require('./subsonic/components/SubsonicLoader');

var _SubsonicLoader2 = _interopRequireDefault(_SubsonicLoader);

var _SubsonicLoadingCard = require('./components/SubsonicLoadingCard');

var _SubsonicLoadingCard2 = _interopRequireDefault(_SubsonicLoadingCard);

var _CastSubsonic = require('./subsonic/context/CastSubsonic');

var _CastSubsonic2 = _interopRequireDefault(_CastSubsonic);

var _RemoteControlKeyHandler = require('./subfire/components/RemoteControlKeyHandler');

var _RemoteControlKeyHandler2 = _interopRequireDefault(_RemoteControlKeyHandler);

var _Snacker = require('./subsonic/components/controls/Snacker');

var _Snacker2 = _interopRequireDefault(_Snacker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-next-line


// import { ChromecastButton } from "subsonic/components/controls/MediaButtons";

window.subsonicClientName = 'SubFireBase';

var DemoButtons = function DemoButtons(props) {
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      _Button2.default,
      { id: 'b1', component: _reactRouterDom.Link, to: '/login' },
      'Login'
    ),
    _react2.default.createElement(
      _Button2.default,
      { id: 'b2', component: _reactRouterDom.Link, to: '/linkClient' },
      'Link Client'
    ),
    _react2.default.createElement(
      _Button2.default,
      { id: 'b3', component: _reactRouterDom.Link, to: '/linkSource' },
      'Link Server'
    ),
    _react2.default.createElement(
      _Button2.default,
      { id: 'b4', onClick: window.openSmall },
      'Go Small'
    ),
    _react2.default.createElement(
      _CredentialsContainer2.default,
      null,
      _react2.default.createElement(_ServerSelect2.default, { handleServerChange: props.handleServerChange })
    )
  );
};

// const nav = {
//   "ArrowLeft": {
//     "#select-server": "#b4",
//     "#b4": "#b3",
//     "#b3": "#b2",
//     "#b2": "#b1"
//   },
//   "ArrowRight": {
//     "#b1": "#b2",
//     "#b2": "#b3",
//     "#b3": "#b4",
//     "#b4": "#select-server"
//   },
//   "ArrowUp": {
//   },
//   "ArrowDown": {
//   }
// }

var styles = function styles(theme) {
  return {
    tableCells: {
      fontSize: '1.5em'
    }
  };
};

var App = function (_Component) {
  _inherits(App, _Component);

  function App() {
    _classCallCheck(this, App);

    var _this = _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).call(this));

    _this.handleCredentialsSubmit = function (id, creds) {
      console.log('logging in or updating', creds);
      _CredentialsActions2.default.saveCredentials(id, creds, true);
    };

    _this.handleServerChange = function (evt) {
      console.log(evt.target.value);
      _CredentialsActions2.default.changeCurrent(evt.target.value, true);
    };

    _this.handleCredentialsDelete = function (id) {
      console.log('delete', id);
      _CredentialsActions2.default.deleteCredentials(id);
    };

    _this.loadPlaylist = function (id, route) {
      var link = '/loading/playlist/' + id + '/list';
      var history = route.history;

      history.push(link);
    };

    _this.playPlaylist = function (id, route, shuffle) {
      var link = '/loading/playlist/' + id;
      if (shuffle) link += '/shuffle';
      var history = route.history;

      history.push(link);
    };

    _this.playPlaylistLink = _react2.default.forwardRef(function (props, ref) {
      return _react2.default.createElement(
        _reactRouterDom.Link,
        {
          innerRef: ref,
          to: '/loading/playlist/' + props.id + (props.options && props.options.shuffle ? '/shuffle' : '')
        },
        props.children
      );
    });
    _this.loadAlbum = _react2.default.forwardRef(function (props, ref) {
      return _react2.default.createElement(
        _reactRouterDom.Link,
        { innerRef: ref, to: '/loading/album/' + props.id },
        props.children
      );
    });
    _this.playAlbum = _react2.default.forwardRef(function (props, ref) {
      return _react2.default.createElement(
        _reactRouterDom.Link,
        { innerRef: ref, to: '/loading/directoryAction/' + props.id + '/all' },
        props.children
      );
    });
    _this.loadAlbumID3 = _react2.default.forwardRef(function (props, ref) {
      return _react2.default.createElement(
        _reactRouterDom.Link,
        { innerRef: ref, to: '/loading/albumID3/' + props.id },
        props.children
      );
    });
    _this.playAlbumID3 = _react2.default.forwardRef(function (props, ref) {
      return _react2.default.createElement(
        _reactRouterDom.Link,
        { innerRef: ref, to: '/loading/albumAction/' + props.id + '/play' },
        props.children
      );
    });

    _CredentialsActions2.default.doLogin.defer();
    _this.state = {
      ih: window.innerHeight
    };
    return _this;
  }

  _createClass(App, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _RemotesActions2.default.startCheckingPlaylists();
      window.addEventListener('resize', this.onResize);
    }

    // onResize = evt => {
    //   this.setState({ ih: window.innerHeight });
    // };

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var classes = this.props.classes;


      var loader = function loader(route) {
        return _react2.default.createElement(
          _SubsonicContainer2.default,
          { route: route },
          _react2.default.createElement(_SubsonicLoader2.default, {
            LoadingComponent: _SubsonicLoadingCard2.default,
            remoteRoute: '/remoteControl'
          })
        );
      };

      // dialogs
      var loginDialog = function loginDialog(route) {
        return _react2.default.createElement(
          _CredentialsContainer2.default,
          { route: route },
          _react2.default.createElement(_LoginCredentials2.default, {
            native: window.isTV,
            handleSubmit: _this2.handleCredentialsSubmit,
            handleDelete: _this2.handleCredentialsDelete
          })
        );
      };

      // dialogs
      var importDialog = function importDialog(route) {
        return _react2.default.createElement(
          _CredentialsContainer2.default,
          { route: route },
          _react2.default.createElement(_ImportCredentials2.default, null)
        );
      };

      var digits = (0, _CredentialsActions.allocateDigits)();
      var linkClient = function linkClient(route) {
        return _react2.default.createElement(_AuthCodeClient2.default, {
          route: route,
          handleClose: route.history.goBack,
          digits: digits
        });
      };

      var linkSource = function linkSource(route) {
        return _react2.default.createElement(_AuthCodeSource2.default, {
          route: route,
          handleClose: route.history.goBack,
          handleSubmit: _this2.handleACSubmit
        });
      };

      var demoMain = function demoMain(route) {
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _Card2.default,
            {
              style: {
                padding: '20px'
              }
            },
            _react2.default.createElement(DemoButtons, {
              route: route,
              handleServerChange: _this2.handleServerChange
            })
          ),
          _react2.default.createElement(
            _SubsonicContainer2.default,
            null,
            _react2.default.createElement(_DemoMain2.default, route)
          )
        );
      };

      //       <Navigator navigation={nav} initialElementSelector="#b1"/>

      // var { ih } = this.state;
      var typeographyConfig = {
        // h2: {
        //   fontSize: ih > 900 ? "3.9rem" : ih > 700 ? "2.4rem" : "1.312rem",
        //   lineHeight: ih > 900 ? "4.1rem" : ih > 700 ? "2.6rem" : "1.16667rem"
        // },
        // h4: {
        //   fontSize: "1.125rem",
        //   lineHeight: "2.17rem",
        //   fontWeight: "400"
        // },
        // h5: {
        //   fontSize: ih > 900 ? "2.3rem" : ih > 700 ? "1.5rem" : "1rem",
        //   lineHeight: ih > 900 ? "2.5rem" : ih > 700 ? "1.8rem" : "1.5em",
        //   fontWeight: "300"
        // },
        // caption: {
        //   fontSize: ih > 900 ? "1.2rem" : ih > 700 ? "1.0rem" : "0.75rem",
        //   lineHeight: ih > 900 ? "1.2rem" : ih > 700 ? "1.1rem" : "1.375em"
        // }
      };

      var overrides = {
        // MuiInputBase: {
        //   input: {
        //     fontSize: '1.5rem'
        //   }
        // }
      };

      return _react2.default.createElement(
        _CastSubsonic.CastSubsonicProvider,
        null,
        _react2.default.createElement(
          _reactRouterDom.HashRouter,
          { basename: '/' },
          _react2.default.createElement(
            _ColorContainer2.default,
            null,
            _react2.default.createElement(
              _ColorTheme2.default,
              {
                defaultPrimary: _colors.amber,
                defaultSecondary: _colors.indigo,
                typography: typeographyConfig,
                overrides: overrides
              },
              _react2.default.createElement(_CssBaseline2.default, null),
              _react2.default.createElement(_Snacker2.default, null),
              _react2.default.createElement(
                _SubsonicContainer2.default,
                null,
                _react2.default.createElement(_RemoteConfigInit2.default, null),
                _react2.default.createElement(_RemoteControlKeyHandler2.default, null)
              ),
              _react2.default.createElement(_reactRouterDom.Route, { exact: true, path: '/', component: demoMain }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/load(ing)/:type/:id/:mode?',
                component: loader,
                exact: true,
                strict: true
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/bookmark/:bookmarkId/:position/loading/:type/:id/:mode?',
                component: loader,
                exact: true,
                strict: true
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/prefs',
                render: function render(props) {
                  return _react2.default.createElement(_Preferences2.default, props);
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/remote',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_RemoteConfigScreen2.default, props)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/remoteControl',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_RemoteControl2.default, props)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/player',
                render: function render(props) {
                  return _react2.default.createElement(
                    _CastSubsonic2.default.Consumer,
                    null,
                    function (csProps) {
                      return _react2.default.createElement(
                        _SubsonicContainer2.default,
                        _extends({}, props, { csProps: csProps }),
                        _react2.default.createElement(_DemoPlayer2.default, _extends({}, props, { useFuzzyImage: 'useFuzzyImage' }))
                      );
                    }
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/playlists/:all',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_PlaylistsBrowser2.default, {
                      onSelect: _this2.loadPlaylist,
                      linkComponent: _this2.playPlaylistLink,
                      renderAllPlaylists: props.match.params.all === 'all',
                      renderMode: _PlaylistsBrowser2.default.renderTypes.GRID,
                      showShuffleOption: true
                    })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/playlist/:id',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_PlaylistBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/radio',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_RadioBrowser2.default, {
                      renderMode: _RadioBrowser2.default.renderTypes.GRID,
                      loadPlaylistContents: false
                    })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/albums',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_AlbumQueryBrowser2.default, {
                      native: false,
                      linkComponent: _this2.playAlbum,
                      linkComponentID3: _this2.playAlbumID3,
                      renderMode: _RadioBrowser2.default.renderTypes.GRID,
                      fabProps: {
                        selector: '#album-query-wrapper'
                      }
                    })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/album/:id',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_AlbumSongBrowser2.default, { history: props.history, showBackButton: true })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/artists',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_ArtistsBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/artist/:id',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_ArtistAlbumsBrowser2.default, {
                      linkComponent: _this2.playAlbumID3,
                      history: props.history,
                      showBackButton: true
                    })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/bookmarks',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_BookmarksBrowser2.default, { cellClasses: classes.tableCells })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/nowPlaying',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_NowPlayingBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/podcasts',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_PodcastsBrowser2.default, {
                      podcastProps: { variant: 'h6' },
                      podcastItemProps: { variant: 'subtitle1' }
                    })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/indexes',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_IndexBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/directory/:id',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_DirectoryBrowser2.default, { history: props.history, showBackButton: true })
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/tree',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_TreeBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/search',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_Search2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/videos',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_VideoBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/songs',
                render: function render(props) {
                  return _react2.default.createElement(
                    _SubsonicContainer2.default,
                    props,
                    _react2.default.createElement(_LoadedSongsBrowser2.default, null)
                  );
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, {
                path: '/muppet',
                render: function render(props) {
                  return _react2.default.createElement(_Muppet2.default, { playerType: 'mobile' });
                }
              }),
              _react2.default.createElement(_reactRouterDom.Route, { path: '/login', component: loginDialog }),
              _react2.default.createElement(_reactRouterDom.Route, { path: '/import', component: importDialog }),
              _react2.default.createElement(_reactRouterDom.Route, { path: '/linkClient', component: linkClient }),
              _react2.default.createElement(_reactRouterDom.Route, { path: '/linkSource', component: linkSource })
            )
          )
        )
      );
    }
  }]);

  return App;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(App);
module.exports = exports.default;