'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/** @const {number} Time in milliseconds for minimal progress update */
var TIMER_STEP = exports.TIMER_STEP = 300;

/**
 * Constants of states for media playback
 * @enum {string}
 */
var PLAYER_STATE = exports.PLAYER_STATE = {
  IDLE: 'IDLE',
  LOADING: 'LOADING',
  LOADED: 'LOADED',
  PLAYING: 'PLAYING',
  PAUSED: 'PAUSED',
  STOPPED: 'STOPPED',
  ERROR: 'ERROR'
};