'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GradientBackground = function (_React$Component) {
  _inherits(GradientBackground, _React$Component);

  function GradientBackground(props) {
    _classCallCheck(this, GradientBackground);

    var _this = _possibleConstructorReturn(this, (GradientBackground.__proto__ || Object.getPrototypeOf(GradientBackground)).call(this, props));

    _this.state = {
      currentGradient: 0
    };
    return _this;
  }

  _createClass(GradientBackground, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(props, state) {
      return props.showGradients !== this.props.showGradients || props.gradients !== this.props.gradients || state.currentGradient !== this.state.currentGradient;
    }
  }, {
    key: 'nextGradient',
    value: function nextGradient() {
      if (this.props.single) return;

      var currentGradient = this.state.currentGradient + 1;
      if (currentGradient > this.props.gradients.length) currentGradient = 0;
      this.setState({
        currentGradient: currentGradient
      });
      if (this.props.gradientChanged) this.props.gradientChanged();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.timer = setInterval(this.nextGradient.bind(this), 12000);
    }
  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.gradients !== this.props.gradients || this.props.single !== nextProps.single) {
        this.setState({
          currentGradient: 0
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.timer);
      document.getElementsByTagName('body')[0].style.background = '#000000';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          gradients = _props.gradients,
          showGradients = _props.showGradients;
      var currentGradient = this.state.currentGradient;

      var background = showGradients && gradients.length !== 0 ? gradients[currentGradient] : '#000000';

      // console.log(gradients, showGradients, background);

      document.getElementsByTagName('body')[0].style.background = background;
      return _react2.default.createElement('span', null);
    }
  }]);

  return GradientBackground;
}(_react2.default.Component);

exports.default = GradientBackground;
module.exports = exports.default;