'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _colors = require('../../utils/colors');

var _ColorActions = require('../actions/ColorActions');

var _ColorActions2 = _interopRequireDefault(_ColorActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GradientGeneratingImage = function (_React$Component) {
  _inherits(GradientGeneratingImage, _React$Component);

  function GradientGeneratingImage() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GradientGeneratingImage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GradientGeneratingImage.__proto__ || Object.getPrototypeOf(GradientGeneratingImage)).call.apply(_ref, [this].concat(args))), _this), _this.imageRef = function (img) {
      if (img) {
        img.onload = function () {
          var g = _colors.Gradients.createRandomGradients(img, 10, 30, true);
          if (_this.props.gradientsLoaded) _this.props.gradientsLoaded(g);
          _ColorActions2.default.setGradients(g);
        };
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GradientGeneratingImage, [{
    key: 'render',
    value: function render() {
      var style = {};
      if (this.props.size) {
        style.width = '100%';
        style.maxWidth = this.props.size;
        style.height = 'auto';
      }
      return _react2.default.createElement('img', {
        crossOrigin: 'anonymous',
        alt: '',
        ref: this.imageRef,
        src: this.props.src,
        id: this.props.imageId,
        style: style,
        className: this.props.className
      });
    }
  }]);

  return GradientGeneratingImage;
}(_react2.default.Component);

exports.default = GradientGeneratingImage;

// http://jwshome.aboutjws.info:4040/rest/getCoverArt.view?id=25600&size=348&v=1.14.0&f=json&c=SubFireMobile&u=subfire&s=wxdntor&t=c4452abc7d637b0dc89fc326a0de9c64

module.exports = exports.default;