'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _GridListTile = require('@material-ui/core/GridListTile');

var _GridListTile2 = _interopRequireDefault(_GridListTile);

var _ListSubheader = require('@material-ui/core/ListSubheader');

var _ListSubheader2 = _interopRequireDefault(_ListSubheader);

var _ArrowUpward = require('@material-ui/icons/ArrowUpward');

var _ArrowUpward2 = _interopRequireDefault(_ArrowUpward);

var _ArrowDownward = require('@material-ui/icons/ArrowDownward');

var _ArrowDownward2 = _interopRequireDefault(_ArrowDownward);

var _PlayArrow = require('@material-ui/icons/PlayArrow');

var _PlayArrow2 = _interopRequireDefault(_PlayArrow);

var _styles = require('@material-ui/core/styles');

var _CoverCard = require('../../../subsonic/components/styled/CoverCard');

var _CoverCard2 = _interopRequireDefault(_CoverCard);

var _CoverGridTile = require('../../../subsonic/components/styled/CoverGridTile');

var _CoverGridTile2 = _interopRequireDefault(_CoverGridTile);

var _ScrollToTopFab = require('../../../subsonic/components/styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      // display: "flex",
      // flexWrap: "wrap",
      // justifyContent: "space-around",
      // overflow: "hidden",
      // paddingLeft: 10
    },
    header: {
      backgroundColor: theme.palette.background.paper,
      marginTop: '10px'
    },
    gridList: {
      backgroundColor: '#000000'
    },
    icon: {
      color: 'rgba(255, 255, 255, 0.54)'
    }
  };
};

var RadioBrowser = function (_Component) {
  _inherits(RadioBrowser, _Component);

  function RadioBrowser(props) {
    _classCallCheck(this, RadioBrowser);

    var _this = _possibleConstructorReturn(this, (RadioBrowser.__proto__ || Object.getPrototypeOf(RadioBrowser)).call(this, props));

    _this.updateDimensions = function () {
      _this.setState({ width: window.innerWidth, height: window.innerHeight });
    };

    _this.componentDidMount = function () {
      window.addEventListener('resize', _this.updateDimensions);
      _this.updateDimensions();
    };

    _this.componentWillUnmount = function () {
      window.removeEventListener('resize', _this.updateDimensions);
    };

    _this.scrollIntoView = function (i) {
      var next = 'grid-category-header' + (i * 1 + 1);
      console.warn(next, document.getElementById(next));
      document.getElementById(next).scrollIntoView({
        block: 'start',
        inline: 'nearest',
        behavior: 'smooth'
      });
    };

    _this.myRef = _react2.default.createRef();
    return _this;
  }

  _createClass(RadioBrowser, [{
    key: 'stationCategory',
    value: function stationCategory(s) {
      return s.stationData.radiostation.o ? s.stationData.radiostation.o.t : 'zzzzz no class';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.warn('pl render', this.props);
      var loadPlaylistContents = this.props.loadPlaylistContents;
      var history = this.props.history;
      var playlistRouting = {
        routeToSelectId: function routeToSelectId(id) {
          var link = loadPlaylistContents ? '/loading/playlist/' + id + '/list' : '/loading/station/' + id;
          history.push(link);
        },
        routeToSelectValue: function routeToSelectValue(evt) {
          var id = evt.target.value;
          if (!id) return;
          var link = loadPlaylistContents ? '/loading/playlist/' + id + '/list' : '/loading/station/' + id;
          history.push(link);
        },
        PlayerRefLink: _react2.default.forwardRef(function (props, ref) {
          var link = '/loading/station/' + props.id;
          return _react2.default.createElement(
            _reactRouterDom.Link,
            { innerRef: ref, to: link },
            props.children
          );
        })
      };

      var _props = this.props,
          subsonic = _props.subsonic,
          renderMode = _props.renderMode,
          selectedId = _props.selectedId,
          SubsonicSource = _props.SubsonicSource,
          classes = _props.classes,
          native = _props.native,
          fullWidth = _props.fullWidth,
          label = _props.label,
          includeEmpty = _props.includeEmpty,
          renderEmptyMessage = _props.renderEmptyMessage;
      var stations = subsonic.stations;
      var routeToSelectId = playlistRouting.routeToSelectId,
          routeToSelectValue = playlistRouting.routeToSelectValue,
          PlayerRefLink = playlistRouting.PlayerRefLink;

      var rm = renderMode || RadioBrowser.renderTypes.TABLE;

      var that = this;
      var pl = stations.sort(function (s1, s2) {
        var c1 = that.stationCategory(s1);
        var c2 = that.stationCategory(s2);
        var c = c1.localeCompare(c2);
        if (c === 0) return s1.name.localeCompare(s2.name);
        return c;
      });
      var rv = void 0;

      if (!pl || pl.length === 0) {
        var message = 'No Stations have been added to this server.';
        if (!subsonic.isConnected) {
          message = 'Not yet connected...';
        } else if (subsonic.isBusy) {
          message = 'Still loading...';
        }
        rv = renderEmptyMessage ? renderEmptyMessage(message) : _react2.default.createElement(
          _Paper2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'h4' },
            message
          )
        );
      } else {
        var sortedStations = pl.reduce(function (rv, n, i, ss) {
          var thisCat = n.stationData.radiostation.o ? n.stationData.radiostation.o.t : 'Radio Stations';
          if (rv.categories.indexOf(thisCat) === -1) {
            rv.categories.push(thisCat);
            rv.categoryStations[thisCat] = [];
          }
          rv.categoryStations[thisCat].push(n);
          return rv;
        }, { categories: [], categoryStations: {} });

        if (rm === RadioBrowser.renderTypes.CARDS) {
          var innerWidth = window.innerWidth;

          // const spacing = innerWidth > 560 ? 20 : 6;
          var cellSize = innerWidth > 560 ? 250 : 164;
          // const cols = innerWidth / (cellSize + spacing);
          // const width = cols * (cellSize + spacing);

          rv = _react2.default.createElement(
            _Grid2.default,
            { container: true, className: classes.root },
            _react2.default.createElement(
              _Grid2.default,
              { item: true, xs: 12, className: 'card-grid' },
              sortedStations.categories.map(function (c) {
                return sortedStations.categoryStations[c].map(function (n, i) {
                  return _react2.default.createElement(_CoverCard2.default, {
                    key: n.id,
                    name: n.name,
                    size: cellSize,
                    coverArt: n.coverArt,
                    linkComponent: PlayerRefLink,
                    id: n.id,
                    category: c,
                    link: '/loading/station/' + n.id,
                    SubsonicSource: SubsonicSource
                  });
                });
              })
            )
          );
        } else if (rm === RadioBrowser.renderTypes.GRID) {
          var _innerWidth = window.innerWidth;
          if (this.myRef && this.myRef.current) {
            _innerWidth = this.myRef.current.offsetWidth;
          }
          if (isNaN(_innerWidth)) _innerWidth = 360;

          var spacing = _innerWidth > 360 ? 10 : 6;
          var _cellSize = _innerWidth > 360 ? 170 : 164;
          var cols = _innerWidth / (_cellSize + spacing);
          var width = cols * (_cellSize + spacing);

          var _sortedStations = pl.reduce(function (rv, n, i, ss) {
            var thisCat = n.stationData.radiostation.o ? n.stationData.radiostation.o.t : 'Radio Stations';
            if (rv.categories.indexOf(thisCat) === -1) {
              rv.categories.push(thisCat);
              rv.categoryStations[thisCat] = [];
            }
            rv.categoryStations[thisCat].push(n);
            return rv;
          }, { categories: [], categoryStations: {} });

          rv = _react2.default.createElement(
            'div',
            { className: classes.root, ref: this.myRef },
            _sortedStations.categories.map(function (c, i, a) {
              return _react2.default.createElement(
                _GridList2.default,
                {
                  key: 'category-' + c,
                  className: classes.gridList,
                  cellHeight: _cellSize,
                  style: { width: width },
                  cols: cols,
                  spacing: spacing
                },
                _react2.default.createElement(
                  _GridListTile2.default,
                  {
                    className: classes.header,
                    cols: cols,
                    style: { height: 'auto' }
                  },
                  _react2.default.createElement(
                    _ListSubheader2.default,
                    {
                      id: 'grid-category-header' + i,
                      component: 'div'
                    },
                    _react2.default.createElement(
                      _Typography2.default,
                      { variant: 'h4' },
                      c
                    ),
                    i + 1 < a.length && _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      {
                        style: { width: 48, height: 48 }
                      },
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'Next',
                          onClick: _this2.scrollIntoView.bind(_this2, i)
                        },
                        _react2.default.createElement(_ArrowDownward2.default, null)
                      )
                    ),
                    i + 1 === a.length && _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      {
                        style: { width: 48, height: 48 }
                      },
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'First',
                          onClick: _this2.scrollIntoView.bind(_this2, -1)
                        },
                        _react2.default.createElement(_ArrowUpward2.default, null)
                      )
                    )
                  )
                ),
                _sortedStations.categoryStations[c].map(function (n) {
                  return _react2.default.createElement(_CoverGridTile2.default, {
                    onClick: routeToSelectId.bind({}, n.id),
                    key: n.id,
                    name: n.name,
                    size: _cellSize,
                    coverArt: n.coverArt,
                    linkComponent: PlayerRefLink,
                    id: n.id,
                    SubsonicSource: SubsonicSource
                  });
                })
              );
            }),
            _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
          );
        } else if (rm === RadioBrowser.renderTypes.LIST) {
          rv = _react2.default.createElement(
            'div',
            { className: classes.root, ref: this.myRef },
            _react2.default.createElement(
              _List2.default,
              null,
              sortedStations.categories.map(function (c, i, a) {
                return _react2.default.createElement(
                  _react2.default.Fragment,
                  { key: c },
                  _react2.default.createElement(
                    _ListSubheader2.default,
                    {
                      id: 'grid-category-header' + i,
                      component: 'div'
                    },
                    _react2.default.createElement(
                      _Typography2.default,
                      { variant: 'h4' },
                      c
                    ),
                    i + 1 < a.length && _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      {
                        style: { width: 48, height: 48 }
                      },
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'Next',
                          onClick: _this2.scrollIntoView.bind(_this2, i)
                        },
                        _react2.default.createElement(_ArrowDownward2.default, null)
                      )
                    ),
                    i + 1 === a.length && _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      {
                        style: { width: 48, height: 48 }
                      },
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'First',
                          onClick: _this2.scrollIntoView.bind(_this2, -1)
                        },
                        _react2.default.createElement(_ArrowUpward2.default, null)
                      )
                    )
                  ),
                  sortedStations.categoryStations[c].map(function (n) {
                    return _react2.default.createElement(
                      _ListItem2.default,
                      {
                        key: 'rs' + n.id,
                        button: true,
                        onClick: routeToSelectId.bind({}, n.id)
                      },
                      _react2.default.createElement(
                        _ListItemIcon2.default,
                        null,
                        _react2.default.createElement('img', {
                          alt: '',
                          width: 48,
                          height: 48,
                          src: SubsonicSource.getCoverArtURL(n.coverArt, 48)
                        })
                      ),
                      _react2.default.createElement(_ListItemText2.default, {
                        primary: n.name,
                        secondary: n.songCount + ' songs'
                      }),
                      _react2.default.createElement(
                        _ListItemSecondaryAction2.default,
                        {
                          style: { width: 48, height: 48 }
                        },
                        _react2.default.createElement(
                          _IconButton2.default,
                          {
                            'aria-label': 'Play',
                            component: PlayerRefLink,
                            id: n.id
                          },
                          _react2.default.createElement(_PlayArrow2.default, null)
                        )
                      )
                    );
                  })
                );
              })
            )
          );
        } else if (rm === RadioBrowser.renderTypes.TABLE) {
          rv = _react2.default.createElement(
            _Table2.default,
            null,
            _react2.default.createElement(
              _TableBody2.default,
              null,
              pl.map(function (n) {
                var selected = '' + n.id === '' + selectedId;
                return _react2.default.createElement(
                  _TableRow2.default,
                  { selected: selected, key: 'pl' + n.id },
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    _react2.default.createElement(
                      PlayerRefLink,
                      { id: n.id },
                      _react2.default.createElement('img', {
                        src: _this2.props.SubsonicSource.getCoverArtURL(n.coverArt, 40),
                        alt: n.name
                      })
                    )
                  ),
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    _react2.default.createElement(
                      PlayerRefLink,
                      { id: n.id },
                      n.name
                    )
                  )
                );
              })
            )
          );
        } else if (rm === RadioBrowser.renderTypes.SELECT && native) {
          rv = _react2.default.createElement(
            _FormControl2.default,
            { className: classes.formControl, fullWidth: fullWidth },
            _react2.default.createElement(
              _InputLabel2.default,
              { htmlFor: 'radio-label' },
              label
            ),
            _react2.default.createElement(
              _Select2.default,
              {
                fullWidth: fullWidth,
                native: true,
                value: '' + selectedId,
                onChange: routeToSelectValue,
                input: _react2.default.createElement(_Input2.default, { id: 'radio-label' })
              },
              includeEmpty && _react2.default.createElement('option', { value: '', key: 'empty-value' }),
              sortedStations.categories.map(function (c, i, a) {
                return _react2.default.createElement(
                  'optgroup',
                  { label: c, key: 'cat-' + c },
                  sortedStations.categoryStations[c].map(function (n) {
                    return _react2.default.createElement(
                      'option',
                      { value: '' + n.id, key: 'pl' + n.id },
                      n.name
                    );
                  })
                );
              })
            )
          );
        } else if (rm === RadioBrowser.renderTypes.SELECT && !native) {
          var v = [];
          if (includeEmpty) {
            v.push(_react2.default.createElement(_MenuItem2.default, { value: '', key: 'empty-value' }));
          }
          sortedStations.categories.forEach(function (c, i, a) {
            v.push(_react2.default.createElement(
              _ListSubheader2.default,
              { key: 'cat-' + c },
              c
            ));
            sortedStations.categoryStations[c].forEach(function (n) {
              return v.push(_react2.default.createElement(
                _MenuItem2.default,
                { value: '' + n.id, key: 'pl' + n.id },
                _react2.default.createElement('img', {
                  crossOrigin: 'anonymous',
                  src: _this2.props.SubsonicSource.getCoverArtURL(n.coverArt, 15),
                  alt: pl.name
                }),
                '\xA0',
                n.name
              ));
            });
          });

          rv = _react2.default.createElement(
            _FormControl2.default,
            { className: classes.formControl, fullWidth: fullWidth },
            _react2.default.createElement(
              _InputLabel2.default,
              { htmlFor: 'radio-label' },
              label
            ),
            _react2.default.createElement(
              _Select2.default,
              {
                fullWidth: fullWidth,
                value: '' + selectedId,
                onChange: routeToSelectValue,
                input: _react2.default.createElement(_Input2.default, { id: 'radio-label' })
              },
              v
            ),
            ' '
          );
        }
      }
      return rv;
    }
  }]);

  return RadioBrowser;
}(_react.Component);

RadioBrowser.renderTypes = {
  GRID: 'grid',
  TABLE: 'table',
  LIST: 'list',
  SELECT: 'select',
  CARDS: 'cards'
};
exports.default = (0, _styles.withStyles)(styles)(RadioBrowser);
module.exports = exports.default;