'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _altContainer = require('alt-container');

var _altContainer2 = _interopRequireDefault(_altContainer);

var _ColorStore = require('../../stores/ColorStore');

var _ColorStore2 = _interopRequireDefault(_ColorStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ColorContainer = function ColorContainer(props) {
  return _react2.default.createElement(
    _altContainer2.default,
    {
      stores: {
        colors: _ColorStore2.default,
        gradients: function gradients(props) {
          return {
            store: _ColorStore2.default,
            value: _ColorStore2.default.getState().gradients
          };
        },
        palette: function palette(props) {
          return {
            store: _ColorStore2.default,
            value: _ColorStore2.default.getState().palette
          };
        }
      }
    },
    props.children
  );
};

exports.default = ColorContainer;
module.exports = exports.default;