'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _RemotesActions = require('../../actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RemoteConfigInit = function (_Component) {
  _inherits(RemoteConfigInit, _Component);

  _createClass(RemoteConfigInit, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, lastState) {
      var s = props.SubsonicSource;
      if (s && s.initialized) {
        var id = s.fetcher._s + '-' + s.fetcher._u;
        // console.log(lastState.initialized, id);
        if (id !== lastState.initialized) {
          lastState.initialized = false;
        }
      }
      return lastState;
    }
  }]);

  function RemoteConfigInit(props) {
    _classCallCheck(this, RemoteConfigInit);

    var _this = _possibleConstructorReturn(this, (RemoteConfigInit.__proto__ || Object.getPrototypeOf(RemoteConfigInit)).call(this, props));

    _this.state = { initialized: false };
    return _this;
  }

  _createClass(RemoteConfigInit, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.initialized === false;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.state.initialized) return;
      if (!this.props.SubsonicSource || !this.props.SubsonicSource.initialized) return;
      _RemotesActions2.default.initRemoteState.defer(this.props.SubsonicSource, this.props.history);

      var s = this.props.SubsonicSource;
      var id = s.fetcher._s + '-' + s.fetcher._u;
      this.setState({
        initialized: id
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.initialized) return;
      if (!this.props.SubsonicSource || !this.props.SubsonicSource.initialized) return;
      _RemotesActions2.default.initRemoteState.defer(this.props.SubsonicSource, this.props.history);

      var s = this.props.SubsonicSource;
      var id = s.fetcher._s + '-' + s.fetcher._u;
      this.setState({
        initialized: id
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return RemoteConfigInit;
}(_react.Component);

exports.default = (0, _reactRouter.withRouter)(RemoteConfigInit);
module.exports = exports.default;