'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ColorStoreClass = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _ColorActions = require('../actions/ColorActions');

var _ColorActions2 = _interopRequireDefault(_ColorActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ColorStoreClass = exports.ColorStoreClass = function () {
  function ColorStoreClass() {
    _classCallCheck(this, ColorStoreClass);

    this.bindActions(_ColorActions2.default);

    this.gradients = [];
    this.palette = [];
  }

  _createClass(ColorStoreClass, [{
    key: 'setGradients',
    value: function setGradients(g) {
      this.gradients = g.gradients;
      this.palette = g.palette;
    }
  }, {
    key: 'resetColors',
    value: function resetColors() {
      this.gradients = [];
      this.palette = [];
    }
  }]);

  return ColorStoreClass;
}();

exports.default = _Dispatcher2.default.createStore(ColorStoreClass, 'ColorStore');