'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CastSubsonic = function (_React$Component) {
  _inherits(CastSubsonic, _React$Component);

  function CastSubsonic(props) {
    _classCallCheck(this, CastSubsonic);

    var _this = _possibleConstructorReturn(this, (CastSubsonic.__proto__ || Object.getPrototypeOf(CastSubsonic)).call(this, props));

    _this.updateListener = function (state) {
      _this.setState(state);
      if (_this.props.updateHandler) _this.props.updateHandler(_this.getProps());
    };

    _this.getProps = function () {
      return Object.assign({}, _this.props, _this.state);
    };

    _this.state = window.castSubsonic.playerHandler.getState('init');
    return _this;
  }

  _createClass(CastSubsonic, [{
    key: 'UNSAFE_componentWillMount',
    value: function UNSAFE_componentWillMount() {
      window.castSubsonic.addUpdateListener(this.updateListener);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.castSubsonic.removeUpdateListener(this.updateListener);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var Node = 'span';
      var children = this.props.children;

      // Custom rendering function
      if (typeof this.props.render === 'function') {
        return this.props.render(this.getProps());
      } else if (this.props.component) {
        return _react2.default.createElement(this.props.component, this.getProps());
      }

      // Does not wrap child in a div if we don't have to.
      if (Array.isArray(children)) {
        return _react2.default.createElement(Node, null, children.map(function (child, i) {
          return _react2.default.cloneElement(child, Object.assign({
            key: i
          }, _this2.getProps()));
        }));
      } else if (children) {
        return _react2.default.cloneElement(children, this.getProps());
      } else {
        return _react2.default.createElement(Node, this.getProps());
      }
    }
  }]);

  return CastSubsonic;
}(_react2.default.Component);

exports.default = CastSubsonic;
module.exports = exports.default;