'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _altContainer = require('alt-container');

var _altContainer2 = _interopRequireDefault(_altContainer);

var _CredentialsStore = require('../../stores/CredentialsStore');

var _CredentialsStore2 = _interopRequireDefault(_CredentialsStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CredentialsContainer = function CredentialsContainer(props) {
  return _react2.default.createElement(
    _altContainer2.default,
    {
      inject: {
        route: props.route
      },
      stores: {
        credentials: _CredentialsStore2.default,
        current: function current(props) {
          return {
            store: _CredentialsStore2.default,
            value: _CredentialsStore2.default.getState().creds[_CredentialsStore2.default.getState().current]
          };
        }
      }
    },
    props.children
  );
};

exports.default = CredentialsContainer;
module.exports = exports.default;