'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var styles = function styles(theme) {
  return {
    '@media only screen and (min-width: 360px)': {
      flowText: {
        fontSize: '1.2rem'
      }
    },

    '@media only screen and (min-width: 390px)': {
      flowText: {
        fontSize: '1.224rem'
      }
    },

    '@media only screen and (min-width: 420px)': {
      flowText: {
        fontSize: '1.248rem'
      }
    },

    '@media only screen and (min-width: 450px)': {
      flowText: {
        fontSize: '1.272rem'
      }
    },

    '@media only screen and (min-width: 480px)': {
      flowText: {
        fontSize: '1.296rem'
      }
    },

    '@media only screen and (min-width: 510px)': {
      flowText: {
        fontSize: '1.32rem'
      }
    },

    '@media only screen and (min-width: 540px)': {
      flowText: {
        fontSize: '1.344rem'
      }
    },

    '@media only screen and (min-width: 570px)': {
      flowText: {
        fontSize: '1.368rem'
      }
    },

    '@media only screen and (min-width: 600px)': {
      flowText: {
        fontSize: '1.392rem'
      }
    },

    '@media only screen and (min-width: 630px)': {
      flowText: {
        fontSize: '1.416rem'
      }
    },

    '@media only screen and (min-width: 660px)': {
      flowText: {
        fontSize: '1.44rem'
      }
    },

    '@media only screen and (min-width: 690px)': {
      flowText: {
        fontSize: '1.464rem'
      }
    },

    '@media only screen and (min-width: 720px)': {
      flowText: {
        fontSize: '1.488rem'
      }
    },

    '@media only screen and (min-width: 750px)': {
      flowText: {
        fontSize: '1.512rem'
      }
    },

    '@media only screen and (min-width: 780px)': {
      flowText: {
        fontSize: '1.536rem'
      }
    },

    '@media only screen and (min-width: 810px)': {
      flowText: {
        fontSize: '1.56rem'
      }
    },

    '@media only screen and (min-width: 840px)': {
      flowText: {
        fontSize: '1.584rem'
      }
    },

    '@media only screen and (min-width: 870px)': {
      flowText: {
        fontSize: '1.608rem'
      }
    },

    '@media only screen and (min-width: 900px)': {
      flowText: {
        fontSize: '1.632rem'
      }
    },

    '@media only screen and (min-width: 930px)': {
      flowText: {
        fontSize: '1.656rem'
      }
    },

    '@media only screen and (min-width: 960px)': {
      flowText: {
        fontSize: '1.68rem'
      }
    },

    '@media only screen and (max-width: 360px)': {
      flowText: {
        fontSize: '1.2rem'
      }
    }
  };
};

var FlowText = function FlowText(props) {
  var classes = props.classes,
      children = props.children,
      p = _objectWithoutProperties(props, ['classes', 'children']);

  return _react2.default.createElement(
    _Typography2.default,
    _extends({}, p, { className: classes.flowText }),
    children
  );
};

exports.default = (0, _styles.withStyles)(styles)(FlowText);
module.exports = exports.default;