'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Card = require('@material-ui/core/Card');

var _Card2 = _interopRequireDefault(_Card);

var _styles = require('@material-ui/core/styles');

var _common = require('@material-ui/core/colors/common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  paper: {
    background: 'transparent',
    color: _common2.default.white,
    marginLeft: 10,
    marginRight: 10
  }
};

var HollowCard = function HollowCard(props) {
  return _react2.default.createElement(
    _Card2.default,
    { raised: true, className: props.classes.paper },
    props.children
  );
};

exports.default = (0, _styles.withStyles)(styles)(HollowCard);
module.exports = exports.default;