'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SwipeableDrawer = require('@material-ui/core/SwipeableDrawer');

var _SwipeableDrawer2 = _interopRequireDefault(_SwipeableDrawer);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _ListSubheader = require('@material-ui/core/ListSubheader');

var _ListSubheader2 = _interopRequireDefault(_ListSubheader);

var _ArrowForward = require('@material-ui/icons/ArrowForward');

var _ArrowForward2 = _interopRequireDefault(_ArrowForward);

var _ArrowBack = require('@material-ui/icons/ArrowBack');

var _ArrowBack2 = _interopRequireDefault(_ArrowBack);

var _SongList = require('../browsers/SongList');

var _SongList2 = _interopRequireDefault(_SongList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SongListDrawer = function (_Component) {
  _inherits(SongListDrawer, _Component);

  function SongListDrawer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SongListDrawer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SongListDrawer.__proto__ || Object.getPrototypeOf(SongListDrawer)).call.apply(_ref, [this].concat(args))), _this), _this.scrollDownList = function (id) {
      var e = document.getElementById(id);
      if (e && e.scrollIntoView) {
        e.scrollIntoView();
      }
    }, _this.handleDrawer = function () {
      var idx = _this.props.subsonic.currentPlaying.idx;
      setTimeout(function () {
        _this.scrollDownList('songs-li-' + idx);
      }, 400);
      if (_this.props.handleDrawer) _this.props.handleDrawer();
    }, _this.handleClose = function () {
      if (_this.props.handleClose) _this.props.handleClose();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SongListDrawer, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      if (this.props.open && !prevProps.open) this.handleDrawer();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          anchor = _props.anchor,
          open = _props.open,
          handleSongClick = _props.handleSongClick,
          subsonic = _props.subsonic;

      var ArrowIcon = anchor === 'right' ? _ArrowForward2.default : _ArrowBack2.default;

      var arrow = anchor === 'right' ? _react2.default.createElement(
        _react2.default.Fragment,
        null,
        'Close ',
        _react2.default.createElement(ArrowIcon, null)
      ) : _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(ArrowIcon, null),
        ' Close'
      );

      return _react2.default.createElement(
        _SwipeableDrawer2.default,
        {
          className: classes.drawer,
          anchor: anchor,
          open: open,
          onClose: this.handleClose,
          onOpen: this.handleDrawer
        },
        _react2.default.createElement(
          _ListSubheader2.default,
          { className: classes.closeButton },
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleClose },
            arrow
          )
        ),
        open ? _react2.default.createElement(_SongList2.default, {
          subsonic: subsonic,
          classes: classes,
          contents: subsonic.currentPlaying.queue,
          idx: subsonic.currentPlaying.idx,
          showCover: false,
          handleSongClick: handleSongClick
        }) : null
      );
    }
  }]);

  return SongListDrawer;
}(_react.Component);

exports.default = SongListDrawer;
module.exports = exports.default;