/** @const {number} Time in milliseconds for minimal progress update */
export var TIMER_STEP = 300;

/**
 * Constants of states for media playback
 * @enum {string}
 */
export var PLAYER_STATE = {
  IDLE: 'IDLE',
  LOADING: 'LOADING',
  LOADED: 'LOADED',
  PLAYING: 'PLAYING',
  PAUSED: 'PAUSED',
  STOPPED: 'STOPPED',
  ERROR: 'ERROR'
};
