import alt from 'Dispatcher';

export const RemoteStates = {
  disabled: 'disabled',
  receiver: 'receiever',
  receiverPaused: 'receiverPaused',
  sender: 'sender'
};

class RemotesActions {
  constructor() {
    this.generateActions(
      'initRemoteState',
      'enableRemoteReceiver',
      'disableRemoteReceiver',
      'checkRemoteState',
      'pauseRemoteReceiver',
      'resumeRemoteReceiver',
      'startCheckingPlaylists',
      'enableSending',
      'disableSending',
      'sendRoute',
      'sendAction',
      'sendInstruction'
    );
  }
}
export default alt.createActions(RemotesActions);
