'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _CastSubsonic = require('./CastSubsonic');

var _CastSubsonic2 = _interopRequireDefault(_CastSubsonic);

require('./setupLocalPlayer');

require('./setupRemotePlayer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var castSubsonic = new _CastSubsonic2.default();

function doInit() {
  if (!window.cast) {
    setTimeout(doInit, 1000);
    return;
  }
  castSubsonic.initializeCastSubsonic();
}

window['__onGCastApiAvailable'] = function (isAvailable) {
  if (isAvailable) {
    doInit();
  }
};
// debugging
window.cp = window.castSubsonic = castSubsonic;

exports.default = castSubsonic;
module.exports = exports.default;