'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Tea = require('../../utils/Tea');

var _Tea2 = _interopRequireDefault(_Tea);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AuthExchangeActions = {
  sourceSubmit: function sourceSubmit(code) {
    try {
      var transmissionDigits = code.substring(0, 5);
      var payloadData = {
        configs: window.localStorage['subsonic.credentials']
      };
      var payload = _Tea2.default.encrypt(JSON.stringify(payloadData), code);
      var myHeaders = new Headers();

      // window.digits = code;
      // window.transmissionDigits = window.digits.substring(0, 6);
      // document.getElementById("code").value = window.transmissionDigits;

      var fd = new FormData();
      fd.set('code', transmissionDigits);
      fd.set('payload', payload);

      var myInit = {
        method: 'POST',
        headers: myHeaders,
        mode: 'cors',
        cache: 'default',
        body: fd
      };
      return fetch('https://subfiresuite.com/sflink/sflink.php', myInit);
    } catch (e) {
      console.error('oops', e);
    }
  },

  clientRequest: function clientRequest(code) {
    var transmissionDigits = code.substring(0, 5);

    var myHeaders = new Headers();
    var myInit = {
      method: 'GET',
      headers: myHeaders,
      mode: 'cors',
      cache: 'default'
    };

    return fetch('https://subfiresuite.com/sflink/sflink.php?code=' + transmissionDigits, myInit);
  }
};

exports.default = AuthExchangeActions;
module.exports = exports.default;