'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemoteStates = undefined;

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RemoteStates = exports.RemoteStates = {
  disabled: 'disabled',
  receiver: 'receiever',
  receiverPaused: 'receiverPaused',
  sender: 'sender'
};

var RemotesActions = function RemotesActions() {
  _classCallCheck(this, RemotesActions);

  this.generateActions('initRemoteState', 'enableRemoteReceiver', 'disableRemoteReceiver', 'checkRemoteState', 'pauseRemoteReceiver', 'resumeRemoteReceiver', 'startCheckingPlaylists', 'enableSending', 'disableSending', 'sendRoute', 'sendAction', 'sendInstruction');
};

exports.default = _Dispatcher2.default.createActions(RemotesActions);