'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mousetrap = require('mousetrap');

var _mousetrap2 = _interopRequireDefault(_mousetrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navigator = function (_PureComponent) {
  _inherits(Navigator, _PureComponent);

  function Navigator() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Navigator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Navigator.__proto__ || Object.getPrototypeOf(Navigator)).call.apply(_ref, [this].concat(args))), _this), _this.back = function (e) {
      window.history.back();
    }, _this.find = function (code, element) {
      var nav = _this.props.navigation;
      var a = nav[code];
      var b = Object.getOwnPropertyNames(a).find(function (c) {
        return element.matches(c);
      });
      // console.warn(b, a, element);
      if (b) {
        // console.warn(a[b], typeof(a[b]), Array.isArray(a[b]));
        return Array.isArray(a[b]) ? a[b] : [a[b]];
      }
      return [];
    }, _this.navigate = function (e) {
      // console.warn('navigate', e.target.id, e.code);
      var nextId = _this.find(e.code, e.target);
      // console.warn(nextId);
      var n = nextId.find(function (sel) {
        // console.warn(sel);
        return document.querySelector(sel);
      });
      // console.warn(n);
      if (n) {
        document.querySelector(n).focus();
      }
    }, _this.hackInitNavigation = function (e) {
      var d = document.querySelector(_this.props.initialElementSelector);
      if (d) {
        console.warn('hackInitNavigation');
        d.focus();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Navigator, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _mousetrap2.default.bind('n a v', this.hackInitNavigation);
      _mousetrap2.default.bind(['up', 'down', 'left', 'right'], this.navigate);
      _mousetrap2.default.bind('esc', this.back);
      _mousetrap2.default.bind('delete', this.back);
      _mousetrap2.default.bind('backspace', this.back);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        this.props.children
      );
    }
  }]);

  return Navigator;
}(_react.PureComponent);

exports.default = Navigator;
module.exports = exports.default;