'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.allocateDigits = undefined;

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CredentialsActions = function CredentialsActions() {
  _classCallCheck(this, CredentialsActions);

  this.generateActions('saveCredentials', 'doLogin', 'changeCurrent', 'importCredentials', 'deleteCredentials', 'importSubFireM1Credentials', 'importSubFirePlayerCredentials', 'totalReset');
};

var allocateDigits = exports.allocateDigits = function allocateDigits() {
  var length = 7;
  var randNumber = Math.floor(Math.random() * (9 * Math.pow(10, length - 1) - 1) + Math.pow(10, length - 1));
  var digits = '' + randNumber;
  return digits;
};

exports.default = _Dispatcher2.default.createActions(CredentialsActions);