'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MusicFolderChooser = function (_Component) {
  _inherits(MusicFolderChooser, _Component);

  function MusicFolderChooser() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MusicFolderChooser);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MusicFolderChooser.__proto__ || Object.getPrototypeOf(MusicFolderChooser)).call.apply(_ref, [this].concat(args))), _this), _this.handleChange = function (evt) {
      if (_this.props.musicFolderChanged) {
        _this.props.musicFolderChanged(evt.target.value);
        return;
      }

      _SubsonicActions2.default.setMusicFolder(evt.target.value);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // props:
  // musicFolder (id)
  // musicFolders
  // musicFolderchnaged (optional)

  _createClass(MusicFolderChooser, [{
    key: 'render',
    value: function render() {
      var props = this.props;
      var native = props.native;

      var musicFolders = props.musicFolders || [];
      var folderItems = musicFolders.map(function (m) {
        if (native) return _react2.default.createElement(
          'option',
          { key: m.id, value: m.id },
          m.name
        );
        return _react2.default.createElement(
          _MenuItem2.default,
          { key: m.id, value: m.id },
          m.name
        );
      });

      var value = (props.musicFolder || -1) * 1;
      //        <Switch label={label} defaultToggled={id3} onToggle={this.handleID3Change} />
      return _react2.default.createElement(
        _FormControl2.default,
        { fullWidth: true },
        _react2.default.createElement(
          _InputLabel2.default,
          { htmlFor: 'folder-query-select' },
          'Music Folder'
        ),
        _react2.default.createElement(
          _Select2.default,
          {
            native: props.native,
            value: value,
            onChange: this.handleChange,
            input: _react2.default.createElement(_Input2.default, { name: 'folder-query', id: 'folder-query-select' })
          },
          folderItems
        )
      );
    }
  }]);

  return MusicFolderChooser;
}(_react.Component);

exports.default = MusicFolderChooser;
module.exports = exports.default;