'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _showNotification = require('../../../utils/showNotification');

var _showNotification2 = _interopRequireDefault(_showNotification);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Notification = function (_React$Component) {
  _inherits(Notification, _React$Component);

  function Notification(props) {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    if (navigator.mediaSession) {
      navigator.mediaSession.setActionHandler('previoustrack', _SubsonicActions2.default.playerPrev);
      navigator.mediaSession.setActionHandler('nexttrack', _SubsonicActions2.default.playerNext);
    }
    return _this;
  }

  _createClass(Notification, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(lastProps) {
      var nextProps = this.props;
      console.log('notification update', lastProps, nextProps);
      var show = false;
      if (nextProps.isPlaying) {
        if (lastProps.song && nextProps.song && nextProps.song.id !== lastProps.song.id) {
          show = true;
        } else if (!lastProps.isPlaying) {
          show = true;
        }
      }
      if (show) (0, _showNotification2.default)(nextProps.song, nextProps.mediaIcon);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var lastProps = this.props;
      var show = false;
      if (nextProps.isPlaying) {
        if (lastProps.song && nextProps.song && nextProps.song.id !== lastProps.song.id) {
          show = true;
        } else if (!lastProps.isPlaying) {
          show = true;
        }
      } else {
        return lastProps.isPlaying;
      }
      return show;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_react2.default.Fragment, null);
    }
  }]);

  return Notification;
}(_react2.default.Component);

exports.default = Notification;
module.exports = exports.default;