'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NowPlaying = function (_Component) {
  _inherits(NowPlaying, _Component);

  _createClass(NowPlaying, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, lastState) {
      var newState = {};
      var _props$subsonic = props.subsonic,
          following = _props$subsonic.following,
          nowPlaying = _props$subsonic.nowPlaying;
      // console.log('following', following, nowPlaying);

      if (following && nowPlaying) {
        var lastSong = lastState && lastState.lastSong ? lastState.lastSong : { id: -1 };
        // console.log('last', lastSong);
        var currentSong = props.subsonic.currentPlaying.queue.length ? props.subsonic.currentPlaying.queue[props.subsonic.currentPlaying.idx] : { id: -1 };
        // console.log('currentSong', currentSong);
        var newSong = nowPlaying.find(function (np) {
          return np.username === following.username && np.playerId === following.playerId;
        });
        // console.log('newSong', newSong);
        if (newSong && newSong.id !== lastSong.id && newSong.id !== currentSong.id) {
          // console.log('appending...');
          newState.lastSong = newSong;
          _SubsonicActions2.default.appendToPlayQueue.defer(newSong);
        }
      }
      return Object.assign({}, lastState, newState);
    }
  }]);

  function NowPlaying(props) {
    _classCallCheck(this, NowPlaying);

    // this.state = NowPlaying.getDerivedStateFromProps(props);
    var _this = _possibleConstructorReturn(this, (NowPlaying.__proto__ || Object.getPrototypeOf(NowPlaying)).call(this, props));

    _this.state = {};
    return _this;
  }

  // componentWillReceiveProps(nextProps) {
  //   this.setState(NowPlaying.getDerivedStateFromProps(nextProps, this.state));
  // }

  _createClass(NowPlaying, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return false;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      _SubsonicActions2.default.getNowPlaying.defer();
      this.interval = setInterval(_SubsonicActions2.default.getNowPlaying.defer, 10000);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.interval);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('span', null);
    }
  }]);

  return NowPlaying;
}(_react.Component);

exports.default = NowPlaying;
module.exports = exports.default;