'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Slider = require('@material-ui/core/Slider');

var _Slider2 = _interopRequireDefault(_Slider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RangeSlider = function (_Component) {
  _inherits(RangeSlider, _Component);

  _createClass(RangeSlider, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      // console.log(
      //   'ds',
      //   props.currentMediaTime,
      //   state.seekValue,
      //   state.isDragging
      // );
      if (state.isDragging) return {
        seekValue: state.seekValue
      };
      return {
        seekValue: props.currentMediaTime
      };
    }
  }]);

  function RangeSlider(props) {
    _classCallCheck(this, RangeSlider);

    var _this = _possibleConstructorReturn(this, (RangeSlider.__proto__ || Object.getPrototypeOf(RangeSlider)).call(this, props));

    _this.sliderChange = function (e, v) {
      _this.setState({ isDragging: true, seekValue: v }, function () {
        _this.props.seekValueChange && _this.props.seekValueChange(_this.state);
      });
    };

    _this.sliderChangeComplete = function () {
      if (_this.props.actions && _this.props.actions.seekTo) {
        _this.props.actions.seekTo(_this.state.seekValue);
      }
      _this.setState({ isDragging: false }, function () {
        _this.props.seekValueChange && _this.props.seekValueChange(_this.state);
      });
    };

    _this.state = {
      isDragging: false
    };
    return _this;
  }

  // sliderChangeStart = () => {
  //   console.warn('start');
  //   this.setState({ isDragging: true }, () => {
  //     this.props.seekValueChange && this.props.seekValueChange(this.state);
  //   });
  // };

  _createClass(RangeSlider, [{
    key: 'render',
    value: function render() {
      var p = this.props;
      var duration = p.duration || 100;
      var durationString = p.duration ? p.durationString : '*:**';
      var horizontalLabels = {
        0: p.currentMediaTimeString
      };
      horizontalLabels[duration] = durationString;

      // it would be nice if this was in the slider already...hopefully mui's will get it right
      // const emptyClassName = this.state.seekValue ? '' : 'empty';
      // labels={horizontalLabels}
      return _react2.default.createElement(
        'div',
        {
          style: {
            overflowX: 'hidden',
            height: 55,
            paddingTop: 20,
            paddingLeft: 20,
            paddingRight: 20
          }
        },
        _react2.default.createElement(_Slider2.default, {
          min: 0,
          max: p.duration || 100,
          value: this.state.seekValue,
          onChange: this.sliderChange,
          onChangeCommitted: this.sliderChangeComplete
        })
      );
    }
  }]);

  return RangeSlider;
}(_react.Component);

exports.default = RangeSlider;
module.exports = exports.default;