'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _notistack = require('notistack');

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _styles = require('@material-ui/core/styles');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _closeSnack = void 0;

var SnackBase = function (_React$Component) {
  _inherits(SnackBase, _React$Component);

  function SnackBase() {
    _classCallCheck(this, SnackBase);

    return _possibleConstructorReturn(this, (SnackBase.__proto__ || Object.getPrototypeOf(SnackBase)).apply(this, arguments));
  }

  _createClass(SnackBase, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // console.warn("setSnackerFunction", this.props.enqueueSnackbar);
      _SubsonicActions2.default.setSnackerFunction({ snack: this.props.enqueueSnackbar });
      window.snack = this.props.enqueueSnackbar;
      _closeSnack = this.props.closeSnackbar;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('span', null);
    }
  }]);

  return SnackBase;
}(_react2.default.Component);

var SnackBaseWithSnackbar = (0, _notistack.withSnackbar)(SnackBase);

function Snacker(props) {
  var classes = props.classes;

  var action = function action(key) {
    return _react2.default.createElement(
      _Button2.default,
      {
        style: { color: '#ffffff' },
        size: 'small',
        key: 'snack-action-dismiss',
        onClick: function onClick() {
          return _closeSnack(key);
        }
      },
      'Dismiss'
    );
  };

  return _react2.default.createElement(
    _notistack.SnackbarProvider,
    {
      classes: { anchorOriginBottomLeft: classes.anchorOriginBottomLeft },
      action: action,
      maxSnack: 3
    },
    _react2.default.createElement(SnackBaseWithSnackbar, null)
  );
}

var styles = function styles(theme) {
  if (window.isTV) return {
    anchorOriginBottomLeft: {
      paddingLeft: '5%',
      paddingBottom: '5%'
    }
  };else return {};
};

exports.default = (0, _styles.withStyles)(styles)(Snacker);
module.exports = exports.default;