'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _GridListTile = require('@material-ui/core/GridListTile');

var _GridListTile2 = _interopRequireDefault(_GridListTile);

var _GridListTileBar = require('@material-ui/core/GridListTileBar');

var _GridListTileBar2 = _interopRequireDefault(_GridListTileBar);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _PlayArrow = require('@material-ui/icons/PlayArrow');

var _PlayArrow2 = _interopRequireDefault(_PlayArrow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CoverGridTile = function CoverGridTile(props) {
  var PlayerRefLink = props.linkComponent;
  var className = props.normal ? '' : 'nowrap';
  var Icon = props.icon || _PlayArrow2.default;
  return _react2.default.createElement(
    _GridListTile2.default,
    {
      title: props.name + (props.subname ? ' - ' + props.subname : ''),
      style: props.style
    },
    _react2.default.createElement('img', {
      crossOrigin: 'anonymous',
      src: props.SubsonicSource.getCoverArtURL(props.coverArt, props.size),
      alt: props.name,
      onClick: props.onClick
    }),
    _react2.default.createElement(_GridListTileBar2.default, {
      title: props.name,
      subtitle: _react2.default.createElement(
        'span',
        null,
        props.subname
      ),
      className: className,
      actionIcon: _react2.default.createElement(
        PlayerRefLink,
        { id: props.id, options: props.options },
        _react2.default.createElement(
          _IconButton2.default,
          null,
          _react2.default.createElement(Icon, null)
        )
      )
    })
  );
};

exports.default = CoverGridTile;
module.exports = exports.default;