'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Avatar = require('@material-ui/core/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    avatar: {
      background: theme.palette.secondary.dark,
      color: '#ffffff'
    }
  };
};

var SubsonicAvatar = function (_React$Component) {
  _inherits(SubsonicAvatar, _React$Component);

  _createClass(SubsonicAvatar, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      var SubsonicSource = props.SubsonicSource;

      state = Object.assign({}, state);
      if (state.avatarURL !== SubsonicSource.fetcher.getAvatarURL()) {
        state.avatarURL = SubsonicSource.fetcher.getAvatarURL();
        state.avatarOK = true;
      }
      return state;
    }
  }]);

  function SubsonicAvatar(props) {
    _classCallCheck(this, SubsonicAvatar);

    var _this = _possibleConstructorReturn(this, (SubsonicAvatar.__proto__ || Object.getPrototypeOf(SubsonicAvatar)).call(this, props));

    _this.handleAvatarError = function () {
      var SubsonicSource = _this.props.SubsonicSource;

      var username = SubsonicSource.fetcher._u;
      // console.warn('avatar error', username, Boolean(username));
      _this.setState({
        avatarOK: !Boolean(username)
      });
    };

    _this.handleAvatarSuccess = function () {
      // console.warn('avatar fine');
      _this.setState({ avatarOK: true });
    };

    _this.state = {
      avatarOK: true
    };
    return _this;
  }

  _createClass(SubsonicAvatar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          SubsonicSource = _props.SubsonicSource;
      var avatarOK = this.state.avatarOK;


      var username = SubsonicSource.fetcher._u;
      var avatarURL = username && avatarOK !== false ? SubsonicSource.fetcher.getAvatarURL() : null;
      //      <IconButton className={classes.menuButton} onClick={this.handleMenu}>

      return _react2.default.createElement(
        _Avatar2.default,
        {
          className: classes.avatar,
          alt: '',
          src: avatarURL,
          imgProps: {
            onError: this.handleAvatarError,
            onLoad: this.handleAvatarSuccess
          }
        },
        avatarOK || username.length === 0 ? '' : username.substring(0, 1).toUpperCase()
      );
    }
  }]);

  return SubsonicAvatar;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(SubsonicAvatar);
module.exports = exports.default;