import Tea from 'utils/Tea';

const AuthExchangeActions = {
  sourceSubmit: function(code) {
    try {
      var transmissionDigits = code.substring(0, 5);
      var payloadData = {
        configs: window.localStorage['subsonic.credentials']
      };
      var payload = Tea.encrypt(JSON.stringify(payloadData), code);
      var myHeaders = new Headers();

      // window.digits = code;
      // window.transmissionDigits = window.digits.substring(0, 6);
      // document.getElementById("code").value = window.transmissionDigits;

      var fd = new FormData();
      fd.set('code', transmissionDigits);
      fd.set('payload', payload);

      var myInit = {
        method: 'POST',
        headers: myHeaders,
        mode: 'cors',
        cache: 'default',
        body: fd
      };
      return fetch('https://subfiresuite.com/sflink/sflink.php', myInit);
    } catch (e) {
      console.error('oops', e);
    }
  },

  clientRequest: function(code) {
    var transmissionDigits = code.substring(0, 5);

    const myHeaders = new Headers();
    const myInit = {
      method: 'GET',
      headers: myHeaders,
      mode: 'cors',
      cache: 'default'
    };

    return fetch(
      'https://subfiresuite.com/sflink/sflink.php?code=' + transmissionDigits,
      myInit
    );
  }
};

export default AuthExchangeActions;
