import alt from 'Dispatcher';
import ColorActions from '../actions/ColorActions';

export class ColorStoreClass {
  constructor() {
    this.bindActions(ColorActions);

    this.gradients = [];
    this.palette = [];
  }

  setGradients(g) {
    this.gradients = g.gradients;
    this.palette = g.palette;
  }

  resetColors() {
    this.gradients = [];
    this.palette = [];
  }
}

export default alt.createStore(ColorStoreClass, 'ColorStore');
