import alt from 'Dispatcher';
/* eslint no-trailing-spaces: */
class SubsonicActions {
  constructor() {
    this.generateActions(
      'startPlayingCurrentQueue',
      'getNowPlaying',
      'returnNowPlaying',
      'followUser',
      'appendToPlayQueue',
      'setOffline',
      'setBusy',
      'setPostLoginRoute',
      'setChromecastAvailable',
      'setChromecastConnected',
      'loginSuccess',
      'loginFailure',
      'refreshPlaylists',
      'retrievedPlaylists',
      'selectPlaylist',
      'populatePlaylist',
      'sortPlaylist',
      'selectStation',
      'populateStation',
      'setInternetStations',
      'playInternetStation',
      'shuffleMusicFolder',
      'fetchPodcasts',
      'returnPodcasts',
      'playPodcast',
      'setAlbumQuery',
      'fetchAlbumPage',
      'returnAlbumPage',
      'playSong',
      'retrievedSong',
      'loadAlbum',
      'setAllArtists',
      'setArtists',
      'setArtistIndex',
      'setArtist',
      'setArtistAlbums',
      'setAlbum',
      'retrievedAlbum',
      'setAndPlayArtistSongs',
      'playArtistSongs',
      'fetchMusicFolders',
      'setMusicFolders',
      'setMusicFolder',
      'setMusicDirectoryIndexes',
      'setMusicDirectoryIndex',
      'setMusicDirectory',
      'retrievedMusicDirectory',
      'playMusicDirectorySongs',
      'startPlaying',
      'stopPlaying',
      'playerNext',
      'playerPrev',
      'playerSkip',
      'playerSkipToTrack',
      'playerSkipToIndex',
      'shufflePlaying',
      'fetchPlayQueue',
      'savePlayQueue',
      'restorePlayQueue',
      'setBookmarkContext',
      'storeBookmarks',
      'getBookmarks',
      'createBookmark',
      'deleteBookmark',
      'setLoadingTitle',
      'setSearchMusicFolder',
      'doSearch',
      'searchResults',
      'toggleMenu',
      'toggleAlbumsAsGrid',
      'setSnackerFunction',
      'getVideos',
      'retrievedVideos'
    );
  }

  snack = (message, options) => {
    console.warn(message, options);
    if (typeof options === 'string') {
      options = { variant: options };
    }
    return [message, options];
  };

  playOrPause = () => {
    window.castSubsonic.playerHandler.playOrPause();
    return true;
  };
  play = () => {
    window.castSubsonic.playerHandler.play();
    return true;
  };
  pause = () => {
    window.castSubsonic.playerHandler.pause(false);
    return true;
  };
}
export default alt.createActions(SubsonicActions);
