import React from 'react';

export default class CastSubsonic extends React.Component {
  constructor(props) {
    super(props);
    this.state = window.castSubsonic.playerHandler.getState('init');
  }

  updateListener = state => {
    this.setState(state);
    if (this.props.updateHandler) this.props.updateHandler(this.getProps());
  };

  UNSAFE_componentWillMount() {
    window.castSubsonic.addUpdateListener(this.updateListener);
  }

  componentWillUnmount() {
    window.castSubsonic.removeUpdateListener(this.updateListener);
  }

  getProps = () => {
    return Object.assign({}, this.props, this.state);
  };

  render() {
    const Node = 'span';
    const children = this.props.children;

    // Custom rendering function
    if (typeof this.props.render === 'function') {
      return this.props.render(this.getProps());
    } else if (this.props.component) {
      return React.createElement(this.props.component, this.getProps());
    }

    // Does not wrap child in a div if we don't have to.
    if (Array.isArray(children)) {
      return React.createElement(
        Node,
        null,
        children.map((child, i) => {
          return React.cloneElement(
            child,
            Object.assign(
              {
                key: i
              },
              this.getProps()
            )
          );
        })
      );
    } else if (children) {
      return React.cloneElement(children, this.getProps());
    } else {
      return React.createElement(Node, this.getProps());
    }
  }
}
