import React, { Component } from 'react';

const CastSubsonicContext = React.createContext(
  window.castSubsonic.playerHandler.getState('init')
);

export class CastSubsonicProvider extends Component {
  constructor(props) {
    super(props);
    this.state = window.castSubsonic.playerHandler.getState('init');
  }

  updateListener = state => {
    this.setState(state);
  };

  UNSAFE_componentWillMount() {
    window.castSubsonic.addUpdateListener(this.updateListener);
  }

  componentWillUnmount() {
    window.castSubsonic.removeUpdateListener(this.updateListener);
  }

  render() {
    return (
      <CastSubsonicContext.Provider value={this.state}>
        {this.props.children}
      </CastSubsonicContext.Provider>
    );
  }
}

export default {
  Provider: CastSubsonicContext.Provider,
  Consumer: CastSubsonicContext.Consumer,
  CastSubsonicProvider: CastSubsonicProvider
};
